<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\Fm0000000HistoricoTransferenciaService;
use FM\Traits\TResponse;

class Fm0000000HistoricoTransferenciaController extends FMCrud {

    use TResponse;

    protected $HistoricoTransferenciaService;

    public function __construct($crudService, $environment, Fm0000000HistoricoTransferenciaService $HistoricoTransferenciaService) {
            parent::__construct($crudService, $environment);
            $this->HistoricoTransferenciaService = $HistoricoTransferenciaService;
    }

    public function getHistoricoTarefas(Request $request, Response $response) {
        try {
                $data = $this->HistoricoTransferenciaService->getHistoricoTarefas();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getHistoricoVistorias(Request $request, Response $response) {
        try {
                $data = $this->HistoricoTransferenciaService->getHistoricoVistorias();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }
}
?>