/* eslint-disable */
// import ZdCalendar from '@/components/calendarTes/ZdCalendar';
import {
  Select, TextInput, Date as DateInput, Time,
} from '@zeedhi/common';
import {
  Http, IDictionary, Loader, Metadata,
} from '@zeedhi/core';
import { Calendar } from '@zeedhi/zd-calendar';

export class CalendarioController {
  public modalController = Loader.getInstance('ModalTask');

  public setFiltroUnidade({ component }: any) {
    const id = (component.name === 'select-unidade') ? 1 : 3;

    component.datasource.setFilter({
      IDTIPOLOCALCLI: id,
    });
  }

  public filterDate() {
    const component = Metadata.getInstance<Calendar>('calendario');
    this.getDados({ component });
  }

  public getDados({ component }: any) {
    let eventos: any = [];
    const dataHoje = new Date();
    const dataInicial = new Date(dataHoje.getFullYear(), dataHoje.getMonth(), 1);
    const dataFinal = new Date(dataHoje.getFullYear(), dataHoje.getMonth()+1, 0);
    const unidade = Metadata.getInstance<Select>('select-unidade').value;

    console.log(component);
   /* Http.get(`/InspectionTask?nr=${localStorage.getItem('UserLogado')}&start=${component.startPeriod}&finish=${component.endPeriod}`).then((response: IDictionary) => {
      response.data.dataset.inspectionTask.forEach((element: IDictionary) => {
        component.eventos.push({
          name: `Vistoria-${element.NMGERENCIAMENTOCHK}`,
          start: new Date(element.DTHORAAGEND),
          end: new Date(element.DTHRFINALAGEND),
          color: (this.getUnidade === null) ? element.DSCORIDLOCAL : element.CORATIVIDADE,
          timed: false,
        });
      });
    }); */
   
    Http.post('/getTarefasCalendario', {
      PERIODOINICIAL: dataInicial.toLocaleDateString(),
      PERIODOFINAL: dataFinal.toLocaleDateString(),
      NRLOCALCLIENTEPAI:unidade,
      NRLOCALCLIENTE: Metadata.getInstance<Select>('select-local').value,
      NRSETOR: Metadata.getInstance<Select>('select-setor').value,
      NRATIVIDADE:Metadata.getInstance<Select>('select-atividade').value,
      NRTIPOLOCALCLI:Metadata.getInstance<Select>('select-tipo-de-local').value,
    }).then((response: IDictionary) => {
      response.data.data.forEach((element: IDictionary) => {
        eventos.push({
          id:element.NRCHECKLISTAGEND,
          name: element.NMCHECKLISTAGEND,
          start: this.formatarData(element.DTHORAAGEND),
          end: this.formatarData(element.DTHRFINALAGEND),
          color: (unidade === null) ? element.DSCORIDLOCAL : element.CORATIVIDADE,
          timed: false,
        });
      });
      component.updateCalendarEvent(eventos);
      eventos = [];
    });
  }

  /* public clickOnEvent(dados: any) {
    this.modalController.openHeaderFooterModal();
    let complemento = '';
    if ((dados.name).indexOf('Vistoria-') > -1) {
      complemento = 'Vistoria-';
    }
    Http.get(`/infoTask?nr=${localStorage.getItem('UserLogado')}&name=${(dados.name).replace(complemento, '')}&start=${dados.start}&end=${dados.end}`).then((response: IDictionary) => {
      const db = response.data.dataset.task[0];
      Metadata.getInstance<TextInput>('InfoLocal').value = `${complemento}${db.NMLOCALCLIENTE}`;
      Metadata.getInstance<TextInput>('InfoLocalType').value = db.NMTIPOLOCALCLI;
      Metadata.getInstance<TextInput>('InfoService').value = '';
      Metadata.getInstance<TextInput>('InfoFunc').value = db.NMFUNCIONARIO;
      [Metadata.getInstance<DateInput>('infoData').value, Metadata.getInstance<Time>('InfoHour').value] = db.DTHORAAGEND.split(' ');
      Metadata.getInstance<TextInput>('InfoDuracao').value = `${((new Date(db.DTHRFINALAGEND)).getTime() - (new Date(db.DTHORAAGEND)).getTime()) / 60000} min`;
      console.log(complemento);
      // Duração em minutos = ((new Date()).getTime() - (new Date()).getTime())/60000
    });
  } */

  public formatarData(data: any) {
    const hora = data.split(' ')[1];
    const dataAmericana = data.split(' ')[0].split('/').reverse().join('-');
    const dataFormatada = `${dataAmericana} ${hora}`;

    return dataFormatada; 
  }
}
