/* eslint-disable */

import { DateRange, Form, Modal, ModalService, SelectMultiple } from '@zeedhi/common';
import { Metadata } from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';
export class Fm00011000ConformidadesGeraisController {
    private conformidadesGerais!: Modal;

    private conformidadesPrincipais!: Modal;


    public setFilter() {
        event?.preventDefault();
        this.exibirModalGerais();
    }

    public setFilterPrincipais() {
        event?.preventDefault();
        this.exibirModalPrincipais();
    }

    public async exibirModalGerais() {
        this.conformidadesGerais = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00011_000_analise_nao_conformidades/modal/fm_00011_003_modal_filtro_nao_conformidades_gerais' });
        this.conformidadesGerais.show();
    }

    public async fecharModalGerais() {
        this.conformidadesGerais.hide();
        this.conformidadesGerais?.destroy();
    }

    public async exibirModalPrincipais() {
        this.conformidadesPrincipais = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00011_000_analise_nao_conformidades/modal/fm_00011_004_modal_filtro_nao_conformidades_principais' });
        this.conformidadesPrincipais.show();
    }

    public async fecharModalPrincipais() {
        this.conformidadesPrincipais.hide();
        this.conformidadesPrincipais?.destroy();
    }

    public setFilterConformidadesGerais() {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-nao-conformidades');
        grid.datasource.setFilter({
            NRLOCALCLIENTE: Metadata.getInstance<SelectMultiple>('filtroLocal').value,
            NRTIPOLOCALCLI: Metadata.getInstance<SelectMultiple>('filtroTipoLocal').value,
            CDOPERADOR:  Metadata.getInstance<SelectMultiple>('filtroUsuario').value,
            CDOPERADORPAI: Metadata.getInstance<SelectMultiple>('filtroGestor').value,
            filtroDataRange: Metadata.getInstance<DateRange>('filtroDataRange').value,
        });
        this.fecharModalGerais();
    }

    public setFilterConformidadesPrincipais() {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-principais-nao-conformidades');
        grid.datasource.setFilter({
            filtroDataRange: Metadata.getInstance<DateRange>('filtroDataRange').value,
        });
        this.fecharModalGerais();
    }
}
